"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseExportCommand = exports.getCodeFromString = exports.parseEmbedJs = exports.Bundler = void 0;
const Transpiler = __importStar(require("./transpiler.js"));
const JsonXYaml_js_1 = require("./structs/JsonXYaml.js");
const enums_js_1 = require("../typings/enums.js");
function Bundler(code, client) {
    const embedJs = parseEmbedJs(code);
    for (const ejs of embedJs) {
        code = code.replace(`\${${ejs}}`, enums_js_1.BundlerCustoms.EJS);
    }
    const command = parseExportCommand(code);
    command.code = Transpiler.Transpiler(command.code, {
        scopeData: {
            embedJs: embedJs,
        },
        sendMessage: true,
        minify: true,
        reverse: command.reverse ?? false,
        client,
    }).func;
    return {
        command: command,
        embedJs
    };
}
exports.Bundler = Bundler;
// this function will get js code from ${} or nested ${} in a string and return it
function parseEmbedJs(fileData) {
    let counter = 0;
    let isPotentialStart = false;
    let temp = "";
    const embedJs = [];
    for (let i = 0; i < fileData.length; i++) {
        const char = fileData[i];
        if (char === "$") {
            if (counter) {
                temp += char;
            }
            if (!isPotentialStart) {
                isPotentialStart = true;
            }
        }
        else if (char === "{") {
            if (isPotentialStart && !counter) {
                counter++;
            }
            else if (counter) {
                temp += char;
                counter++;
            }
        }
        else if (char === "}") {
            if (counter) {
                counter--;
                if (counter === 0) {
                    embedJs.push(temp);
                    temp = "";
                    isPotentialStart = false;
                }
                else {
                    temp += char;
                }
            }
            else if (isPotentialStart) {
                isPotentialStart = false;
            }
        }
        else {
            if (counter) {
                temp += char;
            }
        }
    }
    if (counter) {
        throw new Error("Invalid embed js");
    }
    return embedJs;
}
exports.parseEmbedJs = parseEmbedJs;
function getCodeFromString(s) {
    return s.split("@{").slice(1).join("@{").split("}").slice(0, -1).join("}").trim();
}
exports.getCodeFromString = getCodeFromString;
function parseExportCommand(s) {
    const commandTypeMatchArray = s.match(/\[exportCommand:\s*(\w+)\]/);
    if (!commandTypeMatchArray) {
        throw new Error("Invalid export command");
    }
    const commandType = commandTypeMatchArray[1];
    let command = s.split(commandTypeMatchArray[0])[1].trim();
    command = command.slice(1, command.length - 1);
    const code = getCodeFromString(command);
    command = command.replace(code, code.replaceAll("{", enums_js_1.BundlerCustoms.LB).replaceAll("}", enums_js_1.BundlerCustoms.RB));
    const jsonxyaml = new JsonXYaml_js_1.JsonXYaml(command);
    const obj = jsonxyaml.toObject();
    obj.type = commandType;
    obj.code = obj.code.replaceAll(enums_js_1.BundlerCustoms.LB, "{").replaceAll(enums_js_1.BundlerCustoms.RB, "}");
    return obj;
}
exports.parseExportCommand = parseExportCommand;
//# sourceMappingURL=bundler.js.map