"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.conditionLexer = exports.areSBracketsBalanced = exports.countSBrackets = exports.operators = void 0;
const Condition_js_1 = __importDefault(require("../structs/Condition.js"));
exports.operators = ["===", "!==", "==", "!=", ">", "<", ">=", "<="];
function countSBrackets(condition) {
    const sBrackets = condition.match(/\(/g);
    const eBrackets = condition.match(/\)/g);
    return {
        right: sBrackets ? sBrackets.length : 0,
        left: eBrackets ? eBrackets.length : 0,
    };
}
exports.countSBrackets = countSBrackets;
function areSBracketsBalanced(condition) {
    const { left, right } = countSBrackets(condition);
    return left === right;
}
exports.areSBracketsBalanced = areSBracketsBalanced;
function conditionLexer(condition) {
    let tempCondition;
    if (condition.includes("#FUNCTION_START#")) {
        const matches = condition.match(/((#FUNCTION_START#([$a-z.0-9\s?(){}[\]._:'"`;=><,!-]|\n)+#FUNCTION_END#)|(__\$[a-z_?.()]+\$__))/gim);
        if (matches) {
            for (const match of matches) {
                const newmatch = match
                    .replaceAll("(", "#SMOOTH_BRACKET_LEFT#")
                    .replaceAll(")", "#SMOOTH_BRACKET_RIGHT#");
                condition = condition.replace(match, newmatch);
            }
            tempCondition = condition;
        }
        tempCondition = condition;
    }
    else {
        tempCondition = condition;
    }
    let i = 0;
    let starter = new Condition_js_1.default("");
    while (i < tempCondition.length) {
        if (tempCondition[i] === "(") {
            const nest = new Condition_js_1.default("", starter);
            starter.add("#CONDITION#");
            starter.nest.push(nest);
            starter = nest;
        }
        else if (tempCondition[i] === ")") {
            if (starter.parent)
                starter = starter.parent;
            else
                break;
        }
        else {
            starter.add(tempCondition[i]);
        }
        i++;
    }
    return starter;
}
exports.conditionLexer = conditionLexer;
//# sourceMappingURL=conditionParser.js.map