"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$clientId = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$clientId = {
    name: "$clientId",
    type: "getter",
    brackets: false,
    optional: false,
    fields: [],
    version: "7.0.0",
    default: [],
    returns: "number",
    description: "Returns the ID of client",
    example: `
        $clientId // returns the ID of client
    `,
    code: (data, scope) => {
        // Getting the current scope
        const currentScope = scope[scope.length - 1];
        // Getting the client ID
        const clientId = "__$DISCORD_DATA$__.client?.user.id";
        // Returning the result
        const res = (0, transpilerHelpers_js_1.escapeResult)(clientId);
        currentScope.update(res, data);
        return {
            code: res,
            scope,
        };
    },
};
//# sourceMappingURL=$clientId.js.map