"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$interactionData = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$interactionData = {
    name: "$interactionData",
    brackets: true,
    optional: true,
    type: "getter",
    fields: [
        {
            name: "property",
            type: "string",
            required: true,
            description: "The property to get from the interaction data",
        },
    ],
    description: "gets the interaction data",
    default: ["void"],
    returns: "any",
    version: "7.0.0",
    example: `
        $interactionData[user.id] // returns the user's id of the interaction
    `,
    code: (data, scope) => {
        const currentScope = scope.at(-1);
        //code here
        const property = data.inside;
        const res = (0, transpilerHelpers_js_1.escapeResult)(!property?.trim()
            ? "__$Discord_Data$__.interaction"
            : `__$Discord_Data$__.interaction?.${property}`);
        currentScope.update(res, data);
        return {
            code: res,
            scope,
        };
    },
};
//# sourceMappingURL=$interactionData.js.map