"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$interactionDeferUpdate = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$interactionDeferUpdate = {
    name: "$interactionDeferUpdate",
    brackets: false,
    optional: false,
    type: "setter",
    fields: [],
    description: "defers the interaction for updating from initial 3 seconds response time limit to 15 minutes",
    default: [],
    returns: "void",
    version: "7.0.0",
    example: `
        $interactionDeferUpdate // defers the interaction for updating the original message
    `,
    code: (data, scope) => {
        const currentScope = scope.at(-1);
        //code here
        const res = (0, transpilerHelpers_js_1.escapeResult)("await __$DISCORD_DATA$__.client.createInteractionResponse(__$DISCORD_DATA$__.interaction.id, __$DISCORD_DATA$__.interaction.token,6,undefined);");
        currentScope.update(res, data);
        return {
            code: res,
            scope,
        };
    },
};
//# sourceMappingURL=$interactionDeferUpdate.js.map