"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$eval = void 0;
const index_js_1 = require("../../../index.js");
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$eval = {
    name: "$eval",
    type: "function",
    brackets: true,
    optional: false,
    fields: [
        {
            name: "output",
            type: "boolean",
            description: "Whether to send the output to the channel",
            required: true,
        },
        {
            name: "code",
            type: "string",
            description: "The code to evaluate",
            required: true,
        },
    ],
    default: ["void", "void"],
    returns: "any",
    version: "7.0.0",
    description: "Evaluates the aoi.js code",
    example: `
    $eval[true;$ping] // sends the ping to the channel
    `,
    code: (data, scope) => {
        const [output, ...code] = data.splits;
        const parsedOutput = (0, transpilerHelpers_js_1.convertToBool)(output);
        const currentScope = scope[scope.length - 1];
        const executedCode = `Transpiler(${(0, index_js_1.parseString)(code.join(";"))}, {sendMessage: ${parsedOutput} ,minify: false }).func(__$DISCORD_DATA$__);\n`;
        const res = (0, transpilerHelpers_js_1.escapeResult)(`
    ${executedCode}
    `);
        if (!currentScope.packages.includes("const { Transpiler } = await import('./transpiler.js');")) {
            currentScope.packages += "const { Transpiler } = await import('./transpiler.js');\n";
        }
        currentScope.rest = currentScope.rest.replace(data.total, res);
        data.funcs = [];
        return {
            code: res,
            scope: scope,
            data: data,
        };
    },
};
//# sourceMappingURL=$eval.js.map