"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$authorId = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$authorId = {
    name: "$authorId",
    type: "getter",
    brackets: false,
    optional: false,
    fields: [],
    version: "7.0.0",
    default: [],
    returns: "bigint",
    description: "Returns the id of the author",
    example: "author id is `$authorId`",
    code: (data, scope) => {
        const currentScope = scope[scope.length - 1];
        const authorId = "__$DISCORD_DATA$__.author?.id";
        const res = (0, transpilerHelpers_js_1.escapeResult)(`(${authorId})`);
        currentScope.update(res, data);
        return {
            code: res,
            scope,
        };
    },
};
//# sourceMappingURL=$authorId.js.map