"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$authorName = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$authorName = {
    name: "$authorName",
    type: "getter",
    brackets: false,
    optional: false,
    fields: [],
    version: "7.0.0",
    default: [],
    returns: "string",
    description: "Returns the name of the author",
    example: "author name is `$authorName`",
    code: (data, scope) => {
        const currentScope = scope[scope.length - 1];
        const authorName = "__$DISCORD_DATA$__.author?.username";
        const res = (0, transpilerHelpers_js_1.escapeResult)(`(${authorName})`);
        currentScope.update(res, data);
        return {
            code: res,
            scope,
        };
    },
};
//# sourceMappingURL=$authorName.js.map