"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$authorTag = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$authorTag = {
    name: "$authorTag",
    type: "getter",
    brackets: false,
    optional: false,
    fields: [],
    version: "7.0.0",
    default: [],
    returns: "string",
    description: "Returns the tag of the author",
    example: "author tag is `$authorTag`",
    code: (data, scope) => {
        const currentScope = scope[scope.length - 1];
        const authorTag = "__$DISCORD_DATA$__.author?.tag";
        const res = (0, transpilerHelpers_js_1.escapeResult)(`(${authorTag})`);
        currentScope.update(res, data);
        return {
            code: res,
            scope,
        };
    },
};
//# sourceMappingURL=$authorTag.js.map