"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$comment = void 0;
const transpilerHelpers_js_1 = require("../../../util/transpilerHelpers.js");
exports.$comment = {
    name: "$comment",
    type: "scope",
    brackets: true,
    optional: false,
    version: "7.0.0",
    fields: [
        {
            name: "comment",
            type: "string",
            description: "The comment to convert",
            required: true,
        },
    ],
    default: ["void"],
    returns: "void",
    description: "Converts provided code to a comment",
    example: `
        $comment[hello world] // returns /*hello world*/
    `,
    code: (data, scope) => {
        const comment = data.inside;
        const currentScope = scope[scope.length - 1];
        const res = (0, transpilerHelpers_js_1.escapeResult)(`/*${comment}*/`);
        currentScope.update(res, data);
        return {
            code: res,
            scope: scope,
            data: data,
        };
    },
};
//# sourceMappingURL=$comment.js.map