import { Group } from "@akarui/structures";
import { Command } from "../structures/Command.js";
import { CommandOptions, TranspiledFuncData } from "../typings/interfaces.js";
import { CommandTypes, Optional } from "../typings/types.js";
import { AoiClient } from "../index.js";
export declare class CommandManager {
    #private;
    basic: Group<number, Command>;
    interaction: Group<number, Command>;
    ready: Group<number, Command>;
    debug: Group<number, Command>;
    component: Group<string, Command>;
    constructor(client: AoiClient);
    isValidType(type: string): boolean;
    get types(): string[];
    static cmdTypes(): string[];
    add(command: Optional<CommandOptions, "__path__">): void;
    addMany(commands: Optional<CommandOptions, "__path__">[]): void;
    load({ path, usingAoi, }: {
        path: string;
        usingAoi?: boolean;
    }): Promise<void>;
    exec({ type, data, filter, }: {
        type: CommandTypes;
        data: TranspiledFuncData;
        filter: (cmd: Command) => boolean;
    }): Promise<void>;
    loadFile(filePath: string): Promise<any>;
}
//# sourceMappingURL=Command.d.ts.map