"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FunctionManager = void 0;
const structures_1 = require("@akarui/structures");
const promises_1 = __importDefault(require("fs/promises"));
class FunctionManager {
    client;
    functions = new structures_1.Group(Infinity);
    constructor(client) {
        this.client = client;
    }
    createFunction(data) {
        if (!data.name)
            throw new Error("Function name is required");
        if (!data.code)
            throw new Error("Function code is required");
        this.functions.set(data.name, data);
    }
    createManyFunctions(data) {
        for (const func of data)
            this.createFunction(func);
    }
    async load(path) {
        const stats = await promises_1.default.stat(path);
        if (stats.isDirectory()) {
            const files = await promises_1.default.readdir(path);
            for (const file of files) {
                const filePath = path + "/" + file;
                const stats = await promises_1.default.stat(filePath);
                if (stats.isDirectory())
                    await this.load(filePath);
                else if (stats.isFile() && file.endsWith(".js")) {
                    const func = await import(filePath);
                    this.createFunction(func.default);
                }
            }
        }
    }
}
exports.FunctionManager = FunctionManager;
//# sourceMappingURL=Function.js.map