"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomEvent = void 0;
const events_1 = require("events");
const structures_1 = require("@akarui/structures");
const Command_js_1 = require("./Command.js");
const index_js_1 = require("../index.js");
const path_1 = __importDefault(require("path"));
const promises_1 = __importStar(require("fs/promises"));
class CustomEvent extends events_1.EventEmitter {
    commands;
    #client;
    constructor(client) {
        super();
        this.#client = client;
        this.commands = new structures_1.Group(Infinity);
    }
    listen(eventName) {
        this.on(eventName, async (...args) => {
            const cmds = this.commands.filter((cmd) => cmd.listen === eventName);
            for (const cmd of cmds.values()) {
                await cmd.__compiled__({ bot: this.#client, eventData: args });
            }
        });
    }
    add(command) {
        const cmd = new Command_js_1.Command(command, this.#client);
        this.commands.set(cmd.name, cmd);
    }
    addMany(commands) {
        for (const command of commands)
            this.add(command);
    }
    async load({ path, usingAoi = false, }) {
        const chalk = (await import("chalk")).default;
        const boxen = (await import("boxen")).default;
        const stats = await promises_1.default.stat(path);
        const Commands = [];
        if (!usingAoi) {
            if (stats.isDirectory()) {
                const files = await promises_1.default.readdir(path);
                for (const file of files) {
                    const filePath = path + "/" + file;
                    const stats = await promises_1.default.stat(filePath);
                    if (stats.isDirectory())
                        await this.load({ path: filePath, usingAoi });
                    else if (stats.isFile() && file.endsWith(".js")) {
                        // importing on windows
                        let command;
                        try {
                            if (process.platform === "win32") {
                                const fp = path_1.default.join("file:///", process.cwd(), filePath);
                                command = await import(fp);
                            }
                            else {
                                command = await import(path_1.default.join(process.cwd(), filePath));
                            }
                            if (Array.isArray(command.default)) {
                                this.addMany(command.default);
                            }
                            else
                                this.add(command.default);
                            Commands.push({ path: filePath.split("/").pop(), loaded: true });
                        }
                        catch (e) {
                            /* empty */
                            Commands.push({ path: filePath.split("/").pop(), loaded: false, reason: e });
                        }
                    }
                }
            }
        }
        else {
            if (stats.isDirectory()) {
                const files = await promises_1.default.readdir(path);
                for (const file of files) {
                    const filePath = path + "/" + file;
                    const stats = await promises_1.default.stat(filePath);
                    if (stats.isDirectory())
                        await this.load({ path: filePath, usingAoi });
                    else if (stats.isFile() && file.endsWith(".aoi")) {
                        const command = await (0, promises_1.readFile)(filePath, "utf-8");
                        try {
                            const cmd = (0, index_js_1.Bundler)(command, this.#client).command;
                            cmd.__path__ = filePath;
                            this.add(cmd);
                            Commands.push({ path: filePath.split("/").pop(), loaded: true });
                        }
                        catch (e) {
                            /* empty */
                            Commands.push({ path: filePath.split("/").pop(), loaded: false, reason: e });
                        }
                    }
                    // else if(stats.isFile() && file.endsWith(".aoi") && !file.endsWith(".template.aoi")) {
                    //     const command = await import(filePath);
                    //     this.add(command.default);
                    // }
                }
            }
        }
        const box = boxen(`${Commands.map((cmd) => {
            return `∷ ${chalk.cyanBright(cmd.loaded ? "Loaded" : "Failed")} ${chalk.greenBright(cmd)} ${chalk.redBright(cmd.loaded ? "" : cmd.reason)}`;
        }).join("\n")}
        `, {
            title: `∴ Loading Events ( ${chalk.yellowBright(Commands.length)} )`,
            borderStyle: "round",
            borderColor: "cyan",
            textAlignment: "left",
            backgroundColor: "black",
            width: 100,
            padding: 1,
            dimBorder: true,
            float: "center",
        });
        console.log(box);
    }
}
exports.CustomEvent = CustomEvent;
//# sourceMappingURL=CustomEvent.js.map