import { Group } from "@akarui/structures";
import fs from "fs/promises";
export class FunctionManager {
    client;
    functions = new Group(Infinity);
    constructor(client) {
        this.client = client;
    }
    createFunction(data) {
        if (!data.name)
            throw new Error("Function name is required");
        if (!data.code)
            throw new Error("Function code is required");
        this.functions.set(data.name, data);
    }
    createManyFunctions(data) {
        for (const func of data)
            this.createFunction(func);
    }
    async load(path) {
        const stats = await fs.stat(path);
        if (stats.isDirectory()) {
            const files = await fs.readdir(path);
            for (const file of files) {
                const filePath = path + "/" + file;
                const stats = await fs.stat(filePath);
                if (stats.isDirectory())
                    await this.load(filePath);
                else if (stats.isFile() && file.endsWith(".js")) {
                    const func = await import(filePath);
                    this.createFunction(func.default);
                }
            }
        }
    }
}
//# sourceMappingURL=Function.js.map